scala.tools.nsc.transform.patmat

# ScalaLogic

#### trait ScalaLogic extends Interface with Logic with TreeAndTypeAnalysis

Linear Supertypes
TreeAndTypeAnalysis, Logic, Debugging, Interface, TreeDSL, AnyRef, Any
Known Subclasses
MatchAnalysis, MatchApproximation, MatchOptimization, PatternMatching, patmat
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ScalaLogic
2. TreeAndTypeAnalysis
3. Logic
4. Debugging
5. Interface
6. TreeDSL
7. AnyRef
8. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### trait CheckableTreeAndTypeAnalysis extends AnyRef

   Definition Classes
     TreeAndTypeAnalysis

2. #### trait MatchMonadInterface extends AnyRef

   Interface with user-defined match monad? if there's a `match`in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:``

3. #### trait PropositionalLogic extends AnyRef

   Definition Classes
     Logic

4. #### trait TreesAndTypesDomain extends PropositionalLogic with CheckableTreeAndTypeAnalysis

5. #### trait TypedSubstitution extends MatchMonadInterface

   Definition Classes
     Interface

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     Debugging

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Definition Classes
     Any

3. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ScalaLogic to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (ScalaLogic, B)

   Implicit information
     This member is added by an implicit conversion from ScalaLogic to ArrowAssoc[ScalaLogic] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Definition Classes
     Any

8. #### object CODE

   Definition Classes
     TreeDSL

9. #### def alignAcrossRows(xss: List[List[AnyRef]], sep: String, lineSep: String = "\n"): String

   Definition Classes
     Logic

10. #### final def asInstanceOf[T0]: T0

    Definition Classes
      Any

11. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

12. #### final def dealiasWiden(tp: Global.Type): Global.Type

    Attributes
      protected
    Definition Classes
      Interface

13. #### object debug

    Definition Classes
      Debugging

14. #### final def devWarning(str: String): Unit

    Attributes
      protected
    Definition Classes
      Interface

15. #### def ensuring(cond: (ScalaLogic) ⇒ Boolean, msg: ⇒ Any): ScalaLogic

    Implicit information
      This member is added by an implicit conversion from ScalaLogic to Ensuring[ScalaLogic] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: (ScalaLogic) ⇒ Boolean): ScalaLogic

    Implicit information
      This member is added by an implicit conversion from ScalaLogic to Ensuring[ScalaLogic] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean, msg: ⇒ Any): ScalaLogic

    Implicit information
      This member is added by an implicit conversion from ScalaLogic to Ensuring[ScalaLogic] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean): ScalaLogic

    Implicit information
      This member is added by an implicit conversion from ScalaLogic to Ensuring[ScalaLogic] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

20. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

21. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

22. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ScalaLogic to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

23. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

24. #### final def hasStableSymbol(p: Global.Tree): Boolean

    Attributes
      protected
    Definition Classes
      Interface

25. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

26. #### def instanceOfTpImplies(tp: Global.Type, tpImplied: Global.Type): Boolean

    Definition Classes
      TreeAndTypeAnalysis

27. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

28. #### final def mkFALSE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

29. #### final def mkTRUE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

30. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

31. #### final def notify(): Unit

    Definition Classes
      AnyRef

32. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

33. #### def sameValue(a: Global.Tree, b: Global.Tree): Boolean

    Definition Classes
      TreeAndTypeAnalysis

34. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

35. #### def toString(): String

    Definition Classes
      AnyRef → Any

36. #### object vpmName

    Definition Classes
      Interface

37. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### def →[B](y: B): (ScalaLogic, B)

    Implicit information
      This member is added by an implicit conversion from ScalaLogic to ArrowAssoc[ScalaLogic] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from ScalaLogic to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (scalaLogic: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from ScalaLogic to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (scalaLogic: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: ScalaLogic

   Implicit information
     This member is added by an implicit conversion from ScalaLogic to ArrowAssoc[ScalaLogic] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (scalaLogic: ArrowAssoc[ScalaLogic]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: ScalaLogic

   Implicit information
     This member is added by an implicit conversion from ScalaLogic to Ensuring[ScalaLogic] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (scalaLogic: Ensuring[ScalaLogic]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from TreeAndTypeAnalysis

### Inherited from Logic

### Inherited from Debugging

### Inherited from Interface

### Inherited from TreeDSL

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ScalaLogic to StringAdd

### Inherited by implicit conversion any2stringfmt from ScalaLogic to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from ScalaLogic to ArrowAssoc[ScalaLogic]

### Inherited by implicit conversion any2Ensuring from ScalaLogic to Ensuring[ScalaLogic]

### Ungrouped